/**
** This software is distributed under the terms of the General Public License.  
** 
** Program : BuildIT!
** Version : 0.2
** Authors : Artur Prusakiewicz <prusak@mat.uni.torun.pl>
**	     Michal Switala <scisly@mat.uni.torun.pl>
** E-MAIL  : build@mat.uni.torun.pl
** WWW     : http://www.mat.uni.torun.pl/~scisly/buildit/
**           http://www.mat.uni.torun.pl/~prusak/buildit/
**/
#include "build.h"
#include "../props/Props.h"
#include "ShowTree.h"
#include "Dialog.h"
#include "UserPrefs.h"

#include <pwd.h>
#include <sys/types.h>
#include <unistd.h>
#include <qmainwindow.h> 
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qstatusbar.h>
#include <qwhatsthis.h>

#include <qdir.h> 
#include <qfiledlg.h> 
#include <qwidget.h>
#include <qmenubar.h>
#include <qlabel.h>
#include <qradiobt.h> 
#include <qpopmenu.h>
#include <qkeycode.h>
#include <qapp.h>
#include <qmsgbox.h>
#include <qpushbt.h>
#include <qevent.h> 
#include <qpoint.h>
#include <qlistbox.h>
#include <qrect.h>
#include <qlayout.h>
#include <qbttngrp.h>
#include <qslider.h>
#include <qmlined.h>
#include <qtabdlg.h>
#include <qlistbox.h>
#include <qlined.h>
#include <qgrpbox.h>
#include <qcombo.h>
#include <qstring.h>
#include <qcolor.h>
#include <qpalette.h>
#include <qscrbar.h>


class MainWindow : public QMainWindow
{
Q_OBJECT
public:
  MainWindow(QWidget *parent=0, const char *name=0 );
  int whichLast() { return lastTouched->which; }
  void setActive(QWidget *widget,bool what,bool move=FALSE);
  QString getBigPath(){return bigPath;}
  QString getHomePath(){return homePath;}
  
  MyTree tree[NUMPROJECTS];
  MyTree *pasteTree;
 public slots:
  void newOne();
  void open();
  void save();
  void saveAs();
  void closeIt();
  void exit();
  void undo();
  void cut();
  void copy();
  void paste();
  void prefs();
  void gen();
  void classTree();
  void about();
  void aboutQt();
  bool takePress(QWidget *widget,QMouseEvent *event);
  void takeMove(QWidget *widget,QMouseEvent *event);
  void takeRelease(QWidget *widget,QMouseEvent *event);
  void takeDbClick(QWidget *widget,QMouseEvent *event);
  void setTouched(MyClass *widget);
  void clear(){statusBar()->message("BuildIT! is READY");}
  void watchMouse(int x,int y);
  
  void toggleToolBar();
  void toggleList();

  void setButton(){code=PB;}
  void setCheck_box(){code=RB;}
  void setCanvas(){code=CS;}
  void setChoice(){code=CO;}
  void setList(){code=LI;}
  void setTField(){code=TF;}
  void setTArea(){code=TA;}
  void setScrollBar(){code=SB;}
  void setMenuBar(){code=MB;}
  void setMenuItem(){code=ME;}
  void setLabel(){code=LA;}

  void userPref(); // added
  void updatePref(int preftab[]); // added
private:
  QString bigPath,homePath;
  QMenuBar *menu;
  QPopupMenu *file,*edit,*view,*tools;
  QToolBar *tool,*comps;
  QToolButton *newBT,*openBT,*saveBT,*cutBT,*copyBT,*pasteBT,*undoBT,*genBT,*srcBT;
  QToolButton *bPB,*bCB,*bCS,*bCO,*bLI,*bTF,*bTA,*bSB,*bMB,*bME,*bLA;
  QProgressBar *progress;
  
  Frame *active;
  Dialog *middle;
  int state[NUMPROJECTS];
  int middleH,toolH;
  int place,code,clicked,clickX,clickY;
  int tBar,list,srcItem,genItem,undoItem,cutItem,copyItem,pasteItem,prefsItem,saveItem,saveAsItem,closeItem,userItem;
  bool allowSave,allowCut,allowCopy,allowPaste,allowProps,allowClose,allowUndo,allowTree,allowGen;
  bool canCut,canCopy,canUndo,canPaste,undoProps,canPrefs,canSave,canClose,PasteIT;
  MyClass *lastTouched;
  int options[PREFNUMBER];

  void prepare();
  void setToolBar();
  void createWidget(QWidget *widget,QString id);
  void copyWidget(QWidget *widget,int x,int y,bool undo=FALSE); 
  void ShowReadTree(MyTree *t, QString s,int current);
  bool ShowWidget(MyTree *t, QWidget *parent,bool undo=FALSE,bool first=TRUE);
  void watchWidget(QWidget *widget);
  void saveIt(QString name,bool val);
  void in(int val,QWidget *wgt,QString *toPut);
  void setUndo(QWidget *widget,int cmd);
  void updateView();
  int freeNum();

  //things for undo
  QWidget *toUndo,*undoParent;
  int undoCMD;
  QString undoID;
  int undoT,undoX,undoY,undoW,undoH,u1,u2,u3,u4;
  MyTree *undoTree;
};







